<?php
class ControllerExtensionReportAffiliateTransaction extends Controller {
	public function index() {
		if(!$this->config->get('module_aff_classic_commission_table')) $this->response->redirect($this->url->link('extension/report/customer_transaction', 'user_token=' . $this->session->data['user_token'], true));
		$this->load->language('extension/report/affiliate_transaction');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('setting/setting');		

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$this->model_setting_setting->editSetting('report_affiliate_transaction', $this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');

			$this->response->redirect($this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=report', true));
		}

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_extension'),
			'href' => $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=report', true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('extension/report/affiliate_transaction', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['action'] = $this->url->link('extension/report/affiliate_transaction', 'user_token=' . $this->session->data['user_token'], true);

		$data['cancel'] = $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=report', true);

		if (isset($this->request->post['report_affiliate_transaction_status'])) {
			$data['report_affiliate_transaction_status'] = $this->request->post['report_affiliate_transaction_status'];
		} else {
			$data['report_affiliate_transaction_status'] = $this->config->get('report_affiliate_transaction_status');
		}

		if (isset($this->request->post['report_affiliate_transaction_sort_order'])) {
			$data['report_affiliate_transaction_sort_order'] = $this->request->post['report_affiliate_transaction_sort_order'];
		} else {
			$data['report_affiliate_transaction_sort_order'] = $this->config->get('report_affiliate_transaction_sort_order');
		}

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('extension/report/affiliate_transaction_form', $data));
	}
	
	protected function validate() {
		if (!$this->user->hasPermission('modify', 'extension/report/affiliate_transaction')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		return !$this->error;
	}
		
	public function report() {
		$this->load->language('extension/report/affiliate_transaction');

		if (isset($this->request->get['filter_date_start'])) {
			$filter_date_start = $this->request->get['filter_date_start'];
		} else {
			$filter_date_start = '';
		}

		if (isset($this->request->get['filter_date_end'])) {
			$filter_date_end = $this->request->get['filter_date_end'];
		} else {
			$filter_date_end = '';
		}

		if (isset($this->request->get['filter_customer'])) {
			$filter_customer = $this->request->get['filter_customer'];
		} else {
			$filter_customer = '';
		}
		
		if (isset($this->request->get['filter_balance'])) {
			$filter_balance = $this->request->get['filter_balance'];
		} else {
			$filter_balance = '';
		}		

		if (isset($this->request->get['page'])) {
			$page = $this->request->get['page'];
		} else {
			$page = 1;
		}
		
		$this->load->model('extension/aff_classic');
		$this->load->model('extension/report/affiliate_transaction');
		
		$data['customers'] = array();

		$filter_data = array(
			'filter_date_start'	=> $filter_date_start,
			'filter_date_end'	=> $filter_date_end,
			'filter_customer'	=> $filter_customer,
			'filter_balance'	=> $filter_balance,
			'start'				=> ($page - 1) * $this->config->get('config_limit_admin'),
			'limit'				=> $this->config->get('config_limit_admin')
		);

		$customer_total = $this->model_extension_report_affiliate_transaction->getTotalTransactions($filter_data);

		$results = $this->model_extension_report_affiliate_transaction->getTransactions($filter_data);

		$affiliate_ids = array();
		foreach ($results as $result) {
			$affiliate_ids[] = intval($result['customer_id']);
			$data['customers'][] = array(
				'customer_id'    => $result['customer_id'],
				'customer'       => $result['customer'],
				'email'          => $result['email'],
				'customer_group' => $result['customer_group'],
				'status'         => ($result['status'] ? $this->language->get('text_enabled') : $this->language->get('text_disabled')),
				'total'          => $this->currency->format($result['total'], $this->config->get('config_currency')),
				'total_earnings'          => $this->currency->format($result['total_earnings'], $this->config->get('config_currency')),
				'num_orders' => ($result['orders'] ? intval($result['orders']) : 0),
				'order_total'          => $this->currency->format($result['order_total'], $this->config->get('config_currency')),
				'edit'           => $this->url->link('customer/customer/edit', 'user_token=' . $this->session->data['user_token'] . '&customer_id=' . $result['customer_id'], true)
			);
		}
		
		$payout_accounts = $this->model_extension_aff_classic->getPayoutAccounts($affiliate_ids);
		
		
		foreach($data['customers'] as $_i => $c) {
			$data['customers'][$_i]['has_payout_account'] = isset($payout_accounts[$c['customer_id']]) && $payout_accounts[$c['customer_id']];
		}

		$data['user_token'] = $this->session->data['user_token'];

		$url = '';

		if (isset($this->request->get['filter_date_start'])) {
			$url .= '&filter_date_start=' . $this->request->get['filter_date_start'];
		}

		if (isset($this->request->get['filter_date_end'])) {
			$url .= '&filter_date_end=' . $this->request->get['filter_date_end'];
		}

		if (isset($this->request->get['filter_customer'])) {
			$url .= '&filter_customer=' . urlencode($this->request->get['filter_customer']);
		}
		
		if (isset($this->request->get['filter_balance'])) {
			$url .= '&filter_balance=' . urlencode($this->request->get['filter_balance']);
		}		

		$pagination = new Pagination();
		$pagination->total = $customer_total;
		$pagination->page = $page;
		$pagination->limit = $this->config->get('config_limit_admin');
		$pagination->url = $this->url->link('report/report', 'user_token=' . $this->session->data['user_token'] . '&code=affiliate_transaction' . $url . '&page={page}', true);

		$data['pagination'] = $pagination->render();

		$data['results'] = sprintf($this->language->get('text_pagination'), ($customer_total) ? (($page - 1) * $this->config->get('config_limit_admin')) + 1 : 0, ((($page - 1) * $this->config->get('config_limit_admin')) > ($customer_total - $this->config->get('config_limit_admin'))) ? $customer_total : ((($page - 1) * $this->config->get('config_limit_admin')) + $this->config->get('config_limit_admin')), $customer_total, ceil($customer_total / $this->config->get('config_limit_admin')));

		$data['filter_date_start'] = $filter_date_start;
		$data['filter_date_end'] = $filter_date_end;
		$data['filter_customer'] = $filter_customer;
		$data['filter_balance'] = $filter_balance;

		return $this->load->view('extension/report/affiliate_transaction_info', $data);
	}
}